using System.ComponentModel;
using System.Xml.Serialization;

namespace EQIA.EQIDL
{
    public partial class SpellGem : Control
    {
        private SpellGemDrawTemplate mySpellGemDrawTemplate;
        private int mySpellIconOffsetX, mySpellIconOffsetY;

        [XmlElement("SpellGemDrawTemplate", IsNullable = false)]
        [Browsable(true), Description("Template that defines the art for this spellgem")]
        public SpellGemDrawTemplate SpellGemDrawTemplate { get { return mySpellGemDrawTemplate; } set { mySpellGemDrawTemplate = value; } }

        [XmlElement("SpellIconOffsetX", IsNullable = false)]
        [Browsable(true), Description("Offset of the icon onto this spellgem's background")]
        public int SpellIconOffsetX { get { return mySpellIconOffsetX; } set { mySpellIconOffsetX = value; } }

        [XmlElement("SpellIconOffsetY", IsNullable = false)]
        [Browsable(true), Description("Offset of the icon onto this spellgem's background")]
        public int SpellIconOffsetY { get { return mySpellIconOffsetY; } set { mySpellIconOffsetY = value; } }

        public SpellGem() : this(null) { }
        public SpellGem(EQInterface eqInterface) : base(eqInterface) { }

        protected override void SetProperties(object obj)
        {
            base.SetProperties(obj);

            SpellGem temp_SpellGem = (SpellGem)obj;
            SpellGemDrawTemplate = temp_SpellGem.SpellGemDrawTemplate;
            SpellIconOffsetX = temp_SpellGem.SpellIconOffsetX;
            SpellIconOffsetY = temp_SpellGem.SpellIconOffsetY;

            temp_SpellGem = null;
        }
    }
}
